/*++

Copyright (c) 1997-1998 Microsoft Corporation

Module Name:

	VNDRLIST.H

Abstract:

    This header file contains a list of all currently known USB Vendor IDs
    the vendor name associated with each Vendor ID

Environment:

    Kernel & user mode

Revision History:

    04-25-97 : created

--*/

#ifndef   __VNDRLIST_H__
#define   __VNDRLIST_H__

//
// Vendor ID structure
//
typedef struct {
    USHORT	usVendorID;
    PCHAR	szVendor;
} USBVENDORID, *PUSBVENDORID;

//
// This list built from http://www.teleport.com/~usb/members.htm
// USB Implementors Forum---- 4/17/97
//

USBVENDORID USBVendorIDs[] =
{
    {0x0506, "3Com Corporation"},
    {0x059C, "A-Trend Technology Co., Ltd."},
    {0x04E4, "ACC  Microelectronics"},
    {0x0460, "Ace Cad Enterprise Co., Ltd."},
    {0x049C, "Acer Advanced Labs, Inc."},
    {0x0402, "Acer Labs Inc."},
    {0x04A5, "Acer Peripheral Inc."},
    {0x042E, "Acer, Inc."},
    {0x0502, "Acer, Inc."},
    {0x0515, "ACTC"},
    {0x03F3, "Adaptec, Inc."},
    {0x0422, "ADI Systems"},
    {0x0459, "Adobe Systems, Inc."},
    {0x0522, "Advanced Connectek USA Inc."},
    {0x0428, "Advanced Gravis Computer Tech. Ltd."},
    {0x059D, "Advanced Input Devices"},
    {0x0438, "Advanced Micro Devices"},
    {0x0479, "Advanced Peripheral Laboratories"},
    {0x0476, "AESP"},
    {0x0521, "Airborn Connectors"},
    {0x0533, "Alcatel Mobile Phones"},
    {0x058F, "Alcor Micro, Inc."},
    {0x044E, "Alps Electric Co."},
    {0x0433, "Alps Electric Inc."},
    {0x048C, "Alps Electric Ireland Ltd."},
    {0x04D2, "Altec Lansing Technologies"},
    {0x0527, "ALTRA"},
    {0x0587, "America Kotobuki Electronics Ind."},
    {0x046B, "American Megatrends"},
    {0x0530, "American Microsystems Inc."},
    {0x051D, "American Power Conversion"},
    {0x0464, "AMP Incorporated"},
    {0x0456, "Analog Devices, Inc."},
    {0x0555, "ANAM S&T Co., Ltd."},
    {0x0547, "Anchor Chips Inc."},
    {0x04ED, "Annabooks"},
    {0x03E8, "AOX  Inc."},
    {0x05AC, "Apple Computer"},
    {0x0556, "Asahi Kasei Microsystems Co., Ltd"},
    {0x0418, "AST Research"},
    {0x0486, "ASUS Computers Inc."},
    {0x0467, "AT&T Paradyne"},
    {0x0523, "ATEN GMBH"},
    {0x0557, "ATEN International Co. ltd."},
    {0x0528, "ATI Technologies, Inc."},
    {0x03EB, "Atmel Corporation"},
    {0x052D, "Avid Electronics Corp."},
    {0x057C, "AVM Gmbh"},
    {0x0412, "Award Software International"},
    {0x0509, "Aztech Systems Ltd"},
    {0x0576, "BAFO/Quality Computer Accessories"},
    {0x046E, "Behavior Tech. Computer"},
    {0x050D, "Belkin Components"},
    {0x0514, "Berg Electronics, Inc."},
    {0x04FB, "Biostar Microtech Int'l Corp."},
    {0x05A7, "Bose Corporation"},
    {0x0599, "Brilliance Semiconductor Inc."},
    {0x04EA, "Brooktree Corporation"},
    {0x04F9, "Brother International Corp."},
    {0x0517, "Butterfly Communications"},
    {0x050B, "Cable System International"},
    {0x0559, "Cadence Design Systems"},
    {0x04D6, "CAE Technology"},
    {0x04A9, "Canon Inc."},
    {0x052C, "Canon Information System"},
    {0x0491, "Capetronic"},
    {0x0498, "Capetronic (Kaohsiung) Corp."},
    {0x044C, "CCL/ITRI"},
    {0x05C5, "Central Data Corporation"},
    {0x05C8, "Cheng Uei Precision Industry Co., Ltd"},
    {0x046A, "Cherry Mikroscholter GMBH"},
    {0x04F2, "Chicony Electronics Co., Ltd."},
    {0x0564, "Chinon Industries, Inc."},
    {0x0420, "Chips and Technologies"},
    {0x04AB, "Chromatic Research"},
    {0x0698, "Chuntex (CTX)"},
    {0x050A, "Cinch Connectors"},
    {0x0488, "Cirque Corp."},
    {0x0429, "Cirrus Logic"},
    {0x05A6, "Cisco Systems"},
    {0x0574, "City University of Hong Kong"},
    {0x0508, "Clarion Co., Ltd."},
    {0x0453, "CMD Technology"},
    {0x04B7, "Compal Electronics, Inc."},
    {0x049F, "Compaq Computers"},
    // {0x????, "Compass Communications"},
    {0x0423, "Computer Access Technology Corp."},
    {0x0551, "CompuTrend  Systems, Inc."},
    {0x0478, "Connectix Corp."},
    {0x041E, "Creative Labs"},
    {0x052A, "Crescent Heart Software"},
    {0x0544, "Cristie Electronics Ltd."},
    {0x046F, "Crystal Semiconductor"},
    {0x055E, "CTX Opto-Electronics Corp."},
    {0x04B4, "Cypress Semiconductor"},
    {0x041B, "d'TV"},
    {0x04F0, "Daewoo Electronics Co., Ltd."},
    {0x04AA, "DaeWoo Telecom, Ltd."},
    {0x04FA, "Dallas Semiconductor"},
    {0x03EA, "Data Broadcasting Corp."},
    {0x0501, "DDK Electronics, Inc."},
    {0x056B, "Decicon Incorporated"},
    {0x047C, "Dell Computer Corp."},
    {0x0580, "Denron Inc."},
    {0x0450, "DFI Inc."},
    {0x05B5, "Dialogic Corp"},
    {0x045A, "Diamond Multimedia Systems"},
    {0x0554, "Dictaphone Corp."},
    {0x03F4, "Diebold, Inc."},
    {0x04D0, "Digi International"},
    {0x04A0, "Digital Equipment Corp."},
    {0x05BA, "Digital Persona"},
    {0x0513, "digital-X, Inc."},
    {0x04AD, "Dooin Electronics"},
    {0x04FF, "E-CMOS Corp."},
    {0x056C, "e-TEK Labs"},
    {0x040A, "Eastman Kodak Co."},
    {0x040F, "Echo Speech Corporation"},
    {0x0572, "EEH Datalink Gmbh"},
    {0x048F, "Eicon Tech."},
    {0x04F3, "Elan Microelectronics Corportation"},
    {0x056E, "Elecom Co., Ltd."},
    {0x053E, "Electronic Accessory Specialists Int."},
    {0x059F, "Electronique D2"},
    {0x051F, "Elite Electronics, Inc."},
    {0x03FC, "Elitegroup Computer Systems"},
    {0x04E7, "ELO TouchSystems"},
    {0x0577, "ELSA"},
    {0x05CC, "ELSA Gmbh"},
    {0x0570, "Epson America"},
    {0x03F8, "Epson Research Center"},
    {0x042A, "Ericsson Austrian, AG"},
    {0x0442, "Ericsson Inc."},
    {0x0495, "ESS Technology, Inc."},
    {0x04E2, "Exar Corporation"},
    {0x0592, "Exide Electronics"},
    {0x0518, "EzKEY Corp."},
    {0x03FE, "Farallon"},
    {0x0529, "Fast Security AG"},
    {0x04A2, "FirePower Systems"},
    {0x05B1, "First International Computer, Inc"},
    {0x0585, "FlashPoint Technology, Inc."},
    {0x04D5, "Forte Technologies, Inc."},
    {0x05B0, "Fountain Technologies, Inc"},
    {0x0489, "Foxconn / Hon Hai"},
    {0x0437, "Framatome Connectors USA"},
    {0x05A2, "Fuji Film Microdevices Co. Ltd."},
    {0x04CB, "Fuji Photo Film Co., Ltd."},
    {0x0550, "Fuji Xerox Co., Ltd."},
    {0x04C5, "Fujitsu Limited"},
    {0x04C5, "Fujitsu Ltd."},
    {0x054A, "Fujitsu Microelectronics, Inc.,"},
    {0x0407, "Fujitsu Personal Systems, Inc."},
    {0x0430, "Fujitsu Takamisawa America"},
    {0x0406, "Fujitsu-ICL Computers"},
    {0x04F5, "Fujitsu-ICL Systems, Inc."},
    {0x0403, "Future Technology Devices"},
    {0x04F8, "FuturePlus Systems"},
    {0x049A, "Gandalf Technologies Ltd."},
    {0x0443, "Gateway 2000"},
    {0x03F1, "Genoa Technology"},
    {0x0414, "Giga-Byte Technology Co., Ltd."},
    {0x053B, "Global Village Communication"},
    {0x05BA, "Grey Cell Systems"},
    {0x0579, "GVC Corporation"},
    {0x04F4, "Harting Elektronik Inc."},
    {0x0504, "Hayes Microcomputer Products"},
    {0x03F0, "Hewlett Packard"},
    {0x04B6, "Hint Corporation"},
    {0x0503, "Hitachi America Ltd."},
    {0x045B, "Hitachi, Ltd"},
    {0x04A4, "Hitachi, Ltd."},
    {0x051C, "Holco Enterprise Co., Ltd./Shuttle Computer"},
    {0x04D9, "Holtek Microelectronics Inc."},
    {0x0507, "Hosiden Corporation"},
    {0x0512, "Hualon Microelectronics Corp."},
    {0x04DC, "Huan Hsin C., SDN.BHD"},
    {0x04DB, "Hypertec Pty Ltd."},
    {0x0435, "Hyundai Electronics America"},
    {0x04BB, "I-O Data Device, Inc."},
    {0x04B3, "IBM Corp."},
    {0x04E1, "Iiyama North America Inc."},
    {0x0563, "Immersion Corporation"},
    {0x058C, "In Focus Systems"},
    {0x05AB, "In-System Design"},
    {0x0593, "Incite"},
    {0x050C, "InnoMedia, Inc."},
    {0x042C, "Innovative Semiconductors, Inc."},
    {0x053C, "Institut of Microelectronic & Mechatronic Systems"},
    {0x0426, "Integrated Device Technology"},
    {0x048D, "Integrated Technology Express"},
    {0x8086, "Intel Corporation"},
    {0x042B, "Intel Corporation"},
    {0x059E, "Intelligent Instrumentation"},
    {0x0571, "Interex, Inc."},
    {0x0560, "Interface Co., Ltd."},
    {0x04DF, "Interlink Electronics"},
    {0x0578, "Intrinsix Corp."},
    {0x0537, "Inventec Corporation"},
    {0x059B, "Iomega Corporation"},
    {0x0431, "Itac Systems, Inc."},
    {0x04D1, "ITT Canon"},
    {0x03EC, "Iwatsu America Inc."},
    {0x05AF, "Jing-Mold Enterprise Co., Ltd."},
    {0x05C1, "Kawasaki Steel"},
    {0x050F, "Kawatsu Semiconductor, Inc."},
    {0xC251, "Keil Software"},
    {0x047D, "Kensington"},
    {0x055A, "Kenwood USA"},
    {0x03F9, "KeyTronic Corp."},
    {0x055B, "KnowledgeTek, Inc."},
    {0x04C8, "Konica Corporation"},
    {0x056F, "Korea Data Systems Co., Ltd."},
    {0x0458, "KYE Systems Corp.(Mouse Systems)"},
    {0x0482, "Kyocera Electronics, Inc."},
    {0x041F, "LCS Telegraphics"},
    {0x0413, "Leadtek Research Inc."},
    {0x043D, "Lexmark International Inc."},
    {0x043E, "LG Electronics USA Inc."},
    {0x05B4, "LG Semicon Co., Ltd."},
    {0x0535, "LIH TZU Electric Co., Ltd."},
    {0x04CA, "Lite-On Technology Corp."},
    {0x04C4, "Lockheed Martin Energy Research"},
    {0x046D, "Logitech Inc."},
    {0x0516, "Longwell Electronics"},
    {0x04D4, "LSI Logic Corporation"},
    {0x047E, "Lucent  Microelectronics Technologies"},
    {0x0445, "Lucent Technologies"},
    {0x0445, "Lucent Technologies  IS"},
    {0x05D0, "Lunar Corporation"},
    {0x0493, "MAG Technology Co., Ltd."},
    {0x04C3, "Maxi Switch, Inc."},
    {0x040E, "MCCI"},
    {0x05B7, "Medianix Semiconductor, Inc."},
    {0x05C2, "Mediaphonics S.A."},
    {0x0411, "Melco, Inc."},
    {0x04C2, "Methode Electronics Far East Pte Ltd."},
    {0x0463, "MGE UPS Systems"},
    {0x058D, "Micrel Semiconductor"},
    {0x04AC, "Micro Audiometrics Corp."},
    {0x04D8, "Micro Chip Technology, Inc."},
    {0x0524, "Micro Devices Technology"},
    {0x04C7, "Micro Macro Technologies"},
    {0x0496, "Micron Electronics"},
    {0x042D, "Micronics"},
    {0x045E, "Microsoft"},
    {0x0596, "Microtouch Systems"},
    {0x04DE, "MindShare, Inc."},
    {0x03ED, "Mitel Corporation"},
    {0x0452, "Mitsubishi Electronics America, Inc."},
    {0x03EE, "Mitsumi"},
    {0x042F, "Molex, Inc."},
    {0x0447, "Momentum Microsystems"},
    {0x0534, "Motorola"},
    {0x0427, "Motorola Electronics Taiwan Ltd."},
    {0x0425, "Motorola Semiconductors HK, Ltd."},
    {0x04A8, "Multivideo Labs, Inc."},
    {0x055F, "Mustek Systems Inc."},
    {0x04CF, "Myson Technology Inc."},
    {0x0511, "N'ABLE Technologies, Inc (Data Book)"},
    {0x0440, "NANAO  Corporation"},
    {0x0401, "National Registry Inc."},
    {0x0400, "National Semiconductor"},
    {0x0404, "NCR Corporation"},
    {0x0409, "NEC"},
    {0x050E, "Neon Technology, Inc."},
    {0x0525, "Net Chip Technology, Inc."},
    {0x054B, "New Media Corporation"},
    {0x04F7, "Newnex Technology Corp."},
    {0x0598, "Nigata Canotec Co., Inc."},
    {0x04B0, "Nikon Corporation"},
    {0x057E, "Nintendo Co.,"},
    {0x0446, "NMB Technologies, Inc."},
    {0x0573, "Nogatech Ltd."},
    {0x058A, "Nohau Corporation"},
    {0x04A6, "Nokia Display Products (Salcomp Oy)"},
    {0x0421, "Nokia Mobile Phones"},
    {0x0485, "Nokia Monitors"},
    {0x04F6, "Norand Corporation"},
    {0x045D, "Northern Telecom"},
    {0x04EB, "Northstar Systems, Inc"},
    {0x03F2, "Oak Technology, Inc"},
    {0x0561, "Oasis Design, Inc."},
    {0x04D7, "Oki Semiconductor"},
    {0x05A9, "OmniVision Technologies, Inc."},
    {0x0590, "OMRON Corporation"},
    {0x03FB, "OPTi Inc."},
    {0x05A4, "Ortek Technology, Inc."},
    {0x04EF, "Pacific Electronic International, Inc."},
    {0x0583, "Padix Co. Ltd."},
    {0x04B1, "Pan International"},
    {0x04DA, "Panasonic (Matsushita)"},
    {0x04E9, "PC-Tel Inc."},
    {0x0565, "Peracom Networks, Inc."},
    {0x04FE, "PFU Limited"},
    {0x0471, "Philips"},
    {0x0552, "Philips Monitors"},
    {0x05B9, "Philips Research Laboratories"},
    {0x04CC, "Philips Semiconductors"},
    {0x041A, "Phoenix Technologies, Ltd."},
    {0x0549, "Pixera Corporation"},
    {0x047F, "Plantronics, Inc."},
    {0x0546, "Polaroid Corporation"},
    {0x05CB, "Powerchip Semiconductor Co."},
    {0x053A, "Preh Werke Gmbh & Co. KG"},
    {0x0461, "Primax Electronics"},
    {0x0594, "Princeton Graphic Systems"},
    {0x04E5, "Promise Technology"},
    {0x054E, "Proside Corporation"},
    {0x055C, "Proton Electronic Ind."},
    {0x05B6, "Proxima Corporation"},
    {0x05C7, "Qtronix Corp"},
    {0x05C6, "Qualcomm, Inc"},
    {0x0408, "Quanta Computer Inc."},
    {0x0568, "Quartz Ingenierie"},
    {0x0591, "Questra Consulting"},
    {0x057F, "Quickshot Technology Inc."},
    {0x0581, "Racal Data Group"},
    {0x043F, "RadiSys Corporation"},
    {0x04B9, "Rainbow Technologies, Inc."},
    {0x0584, "RATOC System Inc."},
    {0x05BE, "Raychem Corporation"},
    {0x0475, "Relisys/TECO Information System"},
    {0x05CA, "Ricoh Company Ltd."},
    {0x0572, "Rockwell Semiconductor Systems"},
    {0x04B5, "ROHM LSI Systems, Inc."},
    {0x0582, "Roland Corporation"},
    {0x05BF, "S & S Research"},
    {0x048A, "S-MOS Systems, Inc."},
    {0x041D, "S3, Inc."},
    {0x05A5, "Sampo Technology Corp."},
    {0x055D, "Samsung Electro-Mechanics Co."},
    {0x057A, "Samsung Electronics America"},
    {0x04E8, "Samsung Electronics Co., Ltd."},
    {0x0419, "Samsung Info. Systems America Inc."},
    {0x0434, "Samsung Info. Systems America Inc."},
    {0x0492, "Samsung SemiConductor, Inc."},
    {0x0405, "Sand Microelectronics Inc."},
    {0x0538, "Santa Cruz Operation"},
    {0x0474, "Sanyo Electric Co. Ltd."},
    {0x0473, "Sanyo Information Business Co., Ltd."},
    {0x0588, "Sapien Design"},
    {0x04CE, "ScanLogic Corporation"},
    {0x051E, "Scientific Atlanta"},
    {0x0477, "Seagate Technology"},
    {0x0569, "SegaSoft"},
    {0x04B8, "Seiko Epson Corp."},
    {0x0510, "Sejin Electron Inc."},
    {0x05C9, "Semtech Corporation"},
    {0x0483, "SGS Thomson Microelectronics"},
    {0x044A, "Shamrock Tech. Co., Ltd"},
    {0x057D, "Shark Multimedia Inc."},
    {0x04DD, "Sharp Corporation"},
    {0x04E6, "Shuttle Technology"},
    {0x0539, "Shyh Shiun Terminals Co. LTD"},
    {0x0500, "Siam United Hi-Tech"},
    {0x05CE, "SICAN Gmbh"},
    {0x03F5, "Siemens Electromechanical"},
    {0x044D, "Siemens Nixdorf"},
    {0x058B, "Siemens Semiconductor"},
    {0x05CD, "Silicom LTD."},
    {0x053D, "Silicon Architect"},
    {0x051B, "Silicon Graphics"},
    {0x0457, "Silicon Integrated Systems Corp."},
    {0x047B, "Silitek Corp."},
    {0x04EA, "Sipex Corporation"},
    {0x0541, "Sirf Technology, Inc"},
    {0x0497, "Smile International"},
    {0x04FD, "Soliton Systems, K.K."},
    {0x054C, "Sony Corporation"},
    {0x05A8, "Spacetec IMC Corporation"},
    {0x0484, "Specialix"},
    {0x059A, "Spectrum Signal Processing Inc."},
    {0x0424, "Standard Microsystems Corp."},
    {0x052E, "Standard Microsystems Corp."},
    {0x0519, "Star Micronics America, Inc."},
    {0x0487, "Stewart Connector"},
    {0x0472, "Sun Microsystems"},
    {0x05CF, "Sung Forn Co. LTD."},
    {0x04FC, "Sunplus Technology Co."},
    {0x0575, "Swets & Zeitlinger BV"},
    {0x0417, "Symbios Logic"},
    {0x053F, "Synopsys"},
    {0x05AE, "Synopsys, Inc."},
    {0x0532, "Systech Corporation"},
    {0x049B, "System Connection"},
    {0x04A1, "SystemSoft Corporation"},
    {0x0520, "Taiwan Semiconductor Manufacturing Co."},
    {0x04CD, "Tatung Co. Of America"},
    {0x0436, "Taugagreining HF"},
    {0x04BF, "TDK USA Corporation"},
    {0x052B, "Tekom Development"},
    {0x0455, "Telematics International, Inc."},
    {0x0562, "Telex Communications Inc."},
    {0x04BE, "Telia Research AB"},
    {0x0526, "Temic Matra.mhs"},
    {0x0451, "Texas Instruments"},
    {0x03E9, "Thesys Microelectronics"},
    {0x044F, "ThrustMaster, Inc."},
    {0x04EC, "Tokyo Electron Limited"},
    {0x046C, "Toshiba"},
    {0x04C6, "Toshiba America Electronic Components"},
    {0x0480, "Toshiba America Info. Systems, Inc."},
    {0x04BD, "Toshiba Electronics Taiwan Corp."},
    {0x04BA, "Toucan Systems Ltd."},
    {0x04A3, "Trident Microsystems Inc."},
    {0x058E, "Tripath Technology Inc."},
    {0x0597, "Trisignal Communications"},
    {0x0558, "Truevision, Inc."},
    {0x054D, "Try Corporation"},
    {0x0EF7, "Tulip Computers International"},
    {0x0548, "Tyan Computer Corp."},
    {0x04C1, "U.S. Robotics"},
    {0x052F, "Unicore Software, Inc."},
    {0x0432, "Unisys Corp."},
    {0x0490, "United Microelectronics Corp."},
    {0x0540, "Universal Access"},
    {0x047A, "USAR Systems"},
    {0x05A1, "USC Corporation"},
    {0x05AA, "Utilux South China Ltd."},
    {0x05A3, "VAutomation Inc."},
    {0x05A0, "Vetronix Corporation"},
    {0x040D, "VIA Technologies, Inc."},
    {0x04F1, "Victor Company of Japan"},
    {0x0589, "Victron"},
    {0x04D3, "VidUS, Inc."},
    {0x0543, "View Sonic Corporation"},
    {0x04A7, "Visioneer"},
    {0x049D, "VLSI Technology"},
    {0x0553, "VLSI Vision Ltd."},
    {0x0454, "Vobis Microcomputer AG"},
    {0x0439, "Voice Technologies Group"},
    {0x040C, "VTech Computers Ltd"},
    {0x056A, "WACOM Co., Ltd."},
    {0x0531, "Wacom Technology Corp."},
    {0x0536, "Welch Allyn Inc."},
    {0x040B, "Weltrend Semiconductor"},
    {0x0468, "Wieson Electronic Co., Ltd."},
    {0x0416, "Winbond Electronics Corp."},
    {0x0441, "Winbond Systems Lab."},
    {0x04AF, "Winnov L.P."},
    {0x044B, "WSI"},
    {0x051A, "WYSE Technology"},
    {0x054F, "WYSE Technology Taiwan"},
    {0x03FD, "Xilinx Inc."},
    {0x0545, "Xirlink, Inc."},
    {0x0567, "Xyratex Int'l Ltd."},
    {0x057B, "Y-E Data, Inc."},
    {0x05AD, "Y.C.Cable U.S.A., Inc"},
    {0x0499, "Yamaha Corporation"},
    {0x0481, "Zenith Data Systems"},
    {0x04E3, "Zilog"},
    {0x0595, "Zoran Microelectronics Ltd."},
    {0x0586, "ZyXEL Communications Corp."},
	{ 0x00, "End"}
};

#endif /* __VNDRLIST_H__ */
